# Other software supporting SIXEL graphics
- [sixeldraw](https://github.com/aiju/sixeldraw)

  Sixel support for p9p devdraw

  cmapcube on xterm with DEVDRAW=sixeldraw
  [![sixeldraw2](https://raw.githubusercontent.com/saitoha/libsixel/data/data/sixeldraw2.png)](https://youtu.be/EOvSrt7Yi00)

  acme on xterm with DEVDRAW=sixeldraw SNARF=1
  [![sixeldraw1](https://raw.githubusercontent.com/saitoha/libsixel/data/data/sixeldraw1.png)](https://youtu.be/eGjSEjxiDjE)


- [ZX81 Emulator](https://rullf2.xs4all.nl/sg/zx81ce.html)

  A ZX81 emulator producing Sixel Image Files

  ![ZX81](https://raw.githubusercontent.com/saitoha/libsixel/data/data/zx81.png)


- [qrc](https://github.com/fumiyas/qrc)

  QR code generator for terminals (ASCII Art, Sixel)

  ![qrc](https://github.com/fumiyas/qrc/blob/master/qrc-demo.png)


- [go-sixel](https://github.com/mattn/go-sixel)

  SIXEL encoder/decoder and command line tools writtern in golang.

  ![go-sixel](https://raw.githubusercontent.com/saitoha/libsixel/data/data/go-sixel.png)


- [hiptext](https://github.com/jart/hiptext)

  SIXEL format is supported by -sixel2, -sixel16 or -sixel256 option.

  ![hiptext](https://camo.githubusercontent.com/fc973ffb20a7ff85969df03fd579da2845e62e68/68747470733a2f2f662e636c6f75642e6769746875622e636f6d2f6173736574732f313136323733392f323233393832362f39303361653765382d396335622d313165332d383462362d3539626261346661336430342e706e67)


- [sixelslide](https://github.com/syuu1228/sixelslide)

  Freestanding slideviewer using sixel graphics.
  Currently runs on QEMU(i386), without any filesystem or network.

  ![Animation](https://raw.githubusercontent.com/saitoha/libsixel/data/data/sixelslide.png)

  cf. https://www.slideshare.net/syuu1228/presentation-on-your-terminal

- [SIXEL image viewer](https://rullf2.xs4all.nl/sg/sg.html)

  This web page can decode SIXEL images (written in javascript).

  ![SIXEL image viewer ](https://raw.githubusercontent.com/saitoha/libsixel/data/data/js-sixel.png)


- [mandel4](https://kildall.apana.org.au/~cjb/mandel5.c)

  A mandelbrot program for (colour) sixel-supporting terminals, written by Chris Baird

  ![mandel4](https://raw.githubusercontent.com/saitoha/libsixel/data/data/mandel.png)


- [SixelGraphics.jl(written in Julia)](https://github.com/olofsen/SixelGraphics.jl)

  A module for Julia implementing simple Sixel graphics.

  ![SixelGraphics.jl](https://raw.githubusercontent.com/saitoha/libsixel/data/data/julia.png)


- ![PGPLOT](https://www.astro.caltech.edu/~tjp/pgplot/)


- [SIXEL to PostScript converter](https://t.co/zTC7LhRbBc)


- [sixelplot](https://github.com/kktk-KO/sixelplot)

  thin-wrapper for pysixel and matplotlib


- [ame.sh](https://github.com/hamano/ame.sh)

- [matplotlib-sixel](https://github.com/koppa/matplotlib-sixel)

- [gr framework](https://gr-framework.org/)

- [o2sh/onefetch](https://github.com/o2sh/onefetch)

- [unhappychoice/irasutoya-cli](https://github.com/unhappychoice/irasutoya-cli)

- [ushitora-anqou/tinysixel](https://github.com/ushitora-anqou/tinysixel)

- [adzierzanowski/timg](https://github.com/adzierzanowski/timg)

- [SAT1226/Minase](https://github.com/SAT1226/Minase)

- [danr/neptyne](https://github.com/danr/neptyne)

- [klamonte/jexer](https://github.com/klamonte/jexer)

- [dankamongmen/notcurses](https://github.com/dankamongmen/notcurses)

- [ar90n/teimpy](https://github.com/ar90n/teimpy)

- [fastai](https://github.com/fastai/fastai)

- [coderobe/crixel](https://github.com/coderobe/crixel)

- [itchyny/mkrg](https://github.com/itchyny/mkrg)

- [tshort/SixelTerm.jl](https://github.com/tshort/SixelTerm.jl)

- [dsanson/termpdf](https://github.com/dsanson/termpdf)

- [otiai10/amesh](https://github.com/otiai10/amesh)

- [hpjansson/chafa](https://github.com/hpjansson/chafa)

- [m-j-w/TerminalGraphics.jl](https://github.com/m-j-w/TerminalGraphics.jl)

- [MIC-DKFZ/niicat](https://github.com/MIC-DKFZ/niicat)

- [libretro/RetroArch](https://github.com/libretro/RetroArch)

- [jerch/node-sixel](https://github.com/jerch/node-sixel)

- [nikiroo/fanfix](https://github.com/nikiroo/fanfix)

- [mattn/longcat](https://github.com/mattn/longcat)

- [ismail-yilmaz/upp-components/CtrlLib/Terminal/](https://github.com/ismail-yilmaz/upp-components/tree/master/CtrlLib/Terminal)

- [schrmh/pdfgrepSIXEL](https://github.com/schrmh/pdfgrepSIXEL)

- [ar90n/teimpy](https://github.com/ar90n/teimpy)

- [vifm/vifm](https://github.com/vifm/vifm)

- [ktye/iv](https://github.com/ktye/iv/commit/815e06ed776dde3deca0fdba35da5f0b431a69bf)

- [Delta/longdog](https://github.com/0Delta/longdog)
